﻿// playlist selector class
var playlistSelector = (function(){
	var $type = null;
	var $playlist = null;
	var $keepplaylistview = false;
	
	var selectTrack = function(playlist){
		if($keepplaylistview)return;
		contentarea.removeAllContentItems();
		var current_index = (playlist?-1:iTunesApp.CurrentTrack.PlayOrderIndex);
		var playlist = (playlist?playlist:iTunesApp.CurrentPlaylist);
		var tracks = playlist.Tracks;
		var len = tracks.Count;
		var ci;
		var track;
		var filter = playlistfilter.value.toLowerCase();
		for(var i=len;i>=1;i--){
			ci = new ContentItem();
			track = tracks.ItemByPlayOrder(i);
			if((track.Name+"\t"+track.Artist).toLowerCase().indexOf(filter)>=0){
				ci.heading = ((i==current_index?"♪ ":(i+". "))+track.Name + " - " + track.Artist).replace('&','&amp;').replace('<','&lt;').replace('>','&gt;').replace('"','&quot;');
				with({track:track})
				ci.onOpenItem = function(){playlistfilter.value="";track.Play();$keepplaylistview=false;onrestore();}
				contentarea.addContentItem(ci,gddItemDisplayInSidebar);
			}
		}
		$keepplaylistview = true;
	}
	var selectPlaylist=function(){
		if($keepplaylistview)return;
		contentarea.removeAllContentItems();
		var sources=iTunesApp.Sources;
		var source;
		var playlist;
		var filter = playlistfilter.value.toLowerCase();

		for(var i=sources.Count;i>=1;i--){
			source = sources.Item(i);
			for(var j=source.Playlists.Count;j>=1;j--){
				playlist = source.Playlists.Item(j);
				if((source.Name+"\t"+playlist.Name).toLowerCase().indexOf(filter)>=0){
					ci = new ContentItem();
					ci.heading = (source.Name+":"+playlist.Name).replace('&','&amp;').replace('<','&lt;').replace('>','&gt;').replace('"','&quot;');
					with({playlist:playlist})
					ci.onOpenItem = function(){playlistfilter.value="";$keepplaylistview=false;playlistSelector("track",playlist);}
					contentarea.addContentItem(ci,gddItemDisplayInSidebar);
				}
			}
		}
		$keepplaylistview = true;
	}
	
	var f = function(type,playlist){ //closure
		if(type){
			playlistfilter.value="";
			$type=type;
			if(type=='playlist')$keepplaylistview=false;
		}
		if($type=="track"){
			if(playlist){
				playlistfilter.value="";
				try{
					if(playlist==-1){ // CurrentPlaylist
						$playlist = iTunesApp.CurrentPlaylist;
						if(!$playlist){
							$type="playlist";
							selectPlaylist();
							return;
						}else{
							selectTrack();
						}
					}
				}catch(e){ // selected playlist
					$playlist = playlist;
					selectTrack(playlist);
				}
			}else{ // update view
				selectTrack($playlist);
			}
		}
		if($type=="playlist"){
			selectPlaylist();
		}
	} // end of function f
	f.show=function(){
		waku.visible=false;
		infopanel.popdown();
		playlistfilter.value="";
		playlist.visible=true;
		playlist.enabled=true;
		playlist.height='100%';
		view.setTimeout(function(){
			if($keepplaylistview){
				f();
			}else
				f("track",-1);
				$keepplaylistview=false;
			contentarea.height=view.height-backplayview.height-playlistfilter.height-5;
			contentarea.enabled=true;
		},1);
	}
	f.update=function(){
		$keepplaylistview=false;
		f();
	}
	f.hide=function(force){
		if(!force && $keepplaylistview)return;
		infopanel.popup();
		$keepplaylistview=false;
		playlist.visible=false;
		playlist.enabled=false;
		playlist.height='0';
		playlistfilter.value="";
		waku.visible=true;
		contentarea.enabled=false;
		contentarea.height=0;
		contentarea.removeAllContentItems();
	}
	return f;
})();
